#include <stdlib.h>
#include <fstream.h>
#include <ctype.h>
#include "header.h"
/****************************************************************************/
int  hashkey(int ilg,int didumas)
{
     int h=ilg%didumas;
       return h;
}

/****************************************************************************/
void iterpti(struct sarasas** laik,int didumas,int nauj,char *zodis)
{
   struct sarasas *naujas=NULL;

   naujas=new struct sarasas[sizeof(struct sarasas)];
  // rasti(sarasas**,didumas,ilg,*zodis)
  //  if (naujas->info==zodis)



     for(int j=0;j<=nauj;j++)
     {
       naujas->info[j]=zodis[j];
     }
   naujas->kitas=laik[hashkey(nauj,didumas)];
   laik[hashkey(nauj,didumas)]=naujas;

}

/****************************************************************************/
int rasti(struct sarasas** laik,int didumas,int ilg,char *zodis)
{
   struct sarasas* naujas=NULL;

   naujas=laik[hashkey(ilg,didumas)];
   if(naujas==NULL)
      return 0;
   for(int j=0;j<=ilg;j++)
   {
   while((naujas->info[j]!=zodis[j])&&(naujas->kitas!=NULL))
      naujas=naujas->kitas;
   if(naujas->info[j]==zodis[j])
      return 1;
   else
      return 0;
      }
}

/****************************************************************************/
int istrinti(struct sarasas** laik,int didumas,int ilg,char *zodis)
{
   struct sarasas* naujas=NULL;
   int             key   =hashkey(ilg,didumas);

   naujas=laik[key];
   if(naujas==NULL)
      return 0;
   for(int j=0;j<=ilg;j++)
   {
   if(naujas->info[j]==zodis[j])
   {
      laik[key]=naujas->kitas;
      delete naujas;
      return 1;
   }
   if(naujas->kitas==NULL)
      return 0;
   while((naujas->kitas->info[j]!=zodis[j])&&(naujas->kitas->kitas!=NULL))
      naujas=naujas->kitas;
   if(naujas->kitas->info[j]==zodis[j])
   {
      struct sarasas* pagalb=NULL;

      pagalb=naujas->kitas->kitas;
      delete naujas->kitas;
      naujas->kitas=pagalb;
      return 1;
   }
   return 0;
   }
}

/****************************************************************************/
void spausdinti(struct sarasas** laik,int didumas)
{
   struct sarasas* naujas=NULL;

   cout << "Lenteles dydis yra " << didumas << ".\n";
   cout << "Destymo lentele atrodo taip:\n\n";
   cout << " _________________________...\n";
   cout << " |Kodas\t| Elementai\n";
   cout << " _________________________...\n";

   for(int i=0;i<didumas;i++)
   {
      cout << " |" << i << "\t| ";
      naujas=laik[i];
      while(naujas!=NULL)
      {
         cout << naujas->info << " -> ";
         naujas=naujas->kitas;
      }
      cout << "NULL\n";
   }
   cout << " _________________________...\n";
   cout << "Is viso lenteleje yra elementu: " << kiek_elem(laik,didumas) << ".\n\n";
}

/****************************************************************************/
void nusk_faila(struct sarasas** laik,int didumas)
{
   char pav[20]  ={0},pgb2[30];
   int  elementas=0;

   cout << "Iveskite duomenu failo varda:\n";
   cin >> pav;
   ifstream inf (pav);

   if(inf.fail())
      cerr << "Failas su pavadinimu '" << pav << "' nerastas!\nIsitikinkite, ar duomenu failas egzistuoja, ir pasitikslinkite failo varda.\nTada bandykite dar karta.\n";
   else
   {
      while((!inf.eof())&&(!inf.fail()))
      {
         inf >> pgb2;
         elementas=strlen(pgb2);
         iterpti(laik,didumas,elementas,pgb2);
      }
   if(inf.eof())
      cout << "Failas '" << pav << "' nuskaitytas sekmingai.\n";
   else
      cout << "Skaitant faila '" << pav << "' ivyko klaida.\nGalbut faile yra pasaliniu simboliu.\nNorint, kad failas butu nuskaitytas sekmingai, jame turi buti tik sveikieji skaiciai.\n";
   inf.close();
   istrinti(laik,didumas,elementas,pgb2);
   }
}

/****************************************************************************/
void sp_y_faila(struct sarasas** laik,int didumas)
{
   char pav[20]  ={0};
   struct sarasas* naujas=NULL;

   cout << "Iveskite rezultatu failo varda:\n";
   cin >> pav;

   ofstream outf(pav);
   if(outf.fail())
      cerr << "Saugant duomenis faile, ivyko klaida!\nFailas '" << pav << "' gali buti nesukurtas arba duomenys jame netikslus.\n";
   else
   {
      outf << "Lenteles dydis yra " << didumas << ".\n";
      outf << "Destymo lentele atrodo taip:\n\n";
      outf << " _________________________...\n";
      outf << " |Kodas\t| Elementai\n";
      outf << " _________________________...\n";
      for(int i=0;i<didumas;i++)
      {
         outf << " |" << i << "\t| ";
         naujas=laik[i];
         while(naujas!=NULL)
         {
            outf << naujas->info << " -> ";
            naujas=naujas->kitas;
         }
         outf << "NULL\n";
      }
      outf << " _________________________...\n";
      outf << "Is viso lenteleje yra elementu: " << kiek_elem(laik,didumas) << ".\n\n";
      outf.close();
      cout << "Duomenys sekmingai issaugoti faile '" << pav << "'.\n";
   }
}

/****************************************************************************/
int kiek_elem(struct sarasas** laik,int didumas)
{
   int kiek=0;
   struct sarasas* naujas=NULL;

   for(int i=0;i<didumas;i++)
   {
      naujas=laik[i];
      while(naujas!=NULL)
      {
         naujas=naujas->kitas;
         kiek++;
      }
   }
   return kiek;
}

/****************************************************************************/
void kill(struct sarasas** laik,int didum,int ilg)
{
     for(int i=0;i<didum;i++)
     {
       while(laik[i]!=NULL)
       istrinti(laik,didum,ilg,laik[i]->info);
       delete laik;
     }
}

/****************************************************************************/
int ar_sk(char* duom)
{
   int i=0;

   if(duom[0]=='-')
      i=1;
   for(i;i<strlen(duom);i++)
      if(!isdigit(duom[i]))
         return 0;
   return atoi(duom);
}

/****************************************************************************/
void sp_pagalba()
{
   cout << "/******************************************************************************\n";
   cout << "*/-----------------Dalykas: Duomenu strukturos ir algoritmai-----------------/*\n";
   cout << "*/----------------------------------Salyga-----------------------------------/*\n";
   cout << "*|.....Sudaryti programa, realizuojancia iterpimo, paieskos ir ismetimo......|*\n";
   cout << "*|......operacijas, destymo metodo (hashing) atskirtuose sarasuose, kai......|*\n";
   cout << "*|..............elementai yra kintamo ilgio zodziai..........................|*\n";
   cout << "*/---------------------------------------------------------------------------/*\n";
   cout << "*/--------------------------Autoriaus zodis----------------------------------/*\n";
   cout << "*******************************************************************************\n";
   cout << "*         Programa dar papildyta: meniu, galimybe skaityti failus, apdoroja   *\n";
   cout << "* situacijas, kai vietoje sveikojo skaiciaus ivedamos raides ar kiti simboliai*\n";
   cout << "*  programos vykdymo metu yra galimybe panaikinti destymo lentele ir sukurti  *\n";
   cout << "*   nauja, apdorojama situacija, kai ivedamas neegzistuojancio duomenu failo  *\n";
   cout << "*        vardas, galimybe programos vykdymo metu ivesti lenteles dydi         *\n";
   cout << "*              ir aisku realizuoti visi uzduoties reikalavimai                *\n";
   cout << "*******************************************************************************\n";
}


