/* 13 uzd. Parasyti programa realizuojancia iterpimo, paieskos ir ismetimo
operacijas destymo metodo (hashing) atskirtuose sarasuose, kai elementai yra
kintamo ilgio zodziai*/

// autorius: Miroslav Dvinel MIF 9 gr. II kursas

#include <stdlib.h>  //system("...") ir int atoi(char*)
#include <fstream.h> //ifstream, cout, cin
#include <ctype.h>   //int isdigit(int)
#include "header.h"

main()
{
   int              dydis=10,ilgis;
   char             pgb1[30]={0},pgb[30],meniukey=0;
   struct sarasas** hash=NULL;

   cout << "\n\tPrograma 'Destymas atskirtuose sarasuose' pradeda darba...\n\n\n";
   cout << "Iveskite destymo lenteles dydi:\n";
   do
   {
      if(dydis<1)
      {
        cout << "Jus turite ivesti teigiama skaiciu didesni uz 0!\n";
      }
      cin >> pgb1;
      if(ar_sk(pgb1))
         dydis=ar_sk(pgb1);
      else
         if((strlen(pgb1)==1)&&(pgb1[0]=='0'))
            dydis=0;
         else
         {
            cout << "Jus turite ivesti teigiama skaiciu!\n";
            dydis=0;
         }
   }
   while(dydis<1);
/****************************************************************************/
   hash=new struct sarasas*[dydis];
   for(int i=0;i<dydis;i++)
      hash[i]=NULL;

   do
   {
      cout << "\n1. Itraukti nauja elementa i lentele.\n";
      cout << "2. Itraukti nauja elementa/naujus elementus is failo.\n";
      cout << "3. Atlikti elemento paieska lenteleje.\n";
      cout << "4. Pasalinti elementa is lenteles.\n";
      cout << "5. Atspausdinti lentele kompiuterio ekrane.\n";
      cout << "6. Issaugoti lentele faile.\n";
      cout << "7. Panaikinti visa lentele.\n";
      cout << "8. Apie programa.\n";
      cout << "0. Baigti.\n";
      cin >> meniukey;

     /***************************** 1 ***************************************/
      if (meniukey=='1')
      {
         cout << "Iveskite nauja elementa:\n";
         cin  >> pgb;
         ilgis = strlen(pgb);
         iterpti(hash,dydis,ilgis,pgb);
         cout << "Elementas " << pgb << " sekmingai itrauktas i destymo lentele.\n";
      }
      else
      /***************************** 2 ***************************************/
         if(meniukey=='2')
            nusk_faila(hash,dydis);
         else
      /***************************** 3 ***************************************/
            if(meniukey=='3')
            {
               if(!kiek_elem(hash,dydis))
                  cout << "Lentele siuo metu tuscia!\n";
               else
               {
                  cout << "Iveskite elementa, kurio paieska norite atlikti:\n";

                     cin >> pgb;
                     ilgis = strlen(pgb);

                  if(rasti(hash,dydis,ilgis,pgb))
                     cout << "Elementas " << pgb << " lenteleje yra.\n";
                  else
                     cout << "Elemento " << pgb << " lenteleje nera.\n";
               }
            }
            else
      /***************************** 4 ***************************************/
               if(meniukey=='4')
               {
                if(!kiek_elem(hash,dydis))
                     cout << "Lentele siuo metu tuscia!\n";
                else
                  {
                     cout << "Iveskite elementa, kuri norite pasalinti:\n";

                        cin >> pgb;
                        ilgis = strlen(pgb);

                     if(istrinti(hash,dydis,ilgis,pgb))
                        cout << "Elementas " << pgb << " istrintas.\n";
                     else
                        cout << "Elemento " << pgb << " lenteleje nera.\n";
                  }
               }
               else
      /***************************** 5 ***************************************/
                  if(meniukey=='5')
                  {
                     if(!kiek_elem(hash,dydis))
                        cout << "Lentele siuo metu tuscia!\n";
                     else

                        spausdinti(hash,dydis);
                  }
                  else
      /***************************** 6 ***************************************/
                     if(meniukey=='6')
                     {
                       if(!kiek_elem(hash,dydis))
                           cout << "Lentele siuo metu tuscia!\n";
                       else
                           sp_y_faila(hash,dydis);
                     }
                     else
      /***************************** 7 ***************************************/
                        if(meniukey=='7')
                        {
                           cout << "DEMESIO!\nVisi duomenys ir lentele bus sunaikinti neatstatomai!\n";
                           cout << "Jei jus isitikine, kad norite panaikinti visa lentele, iveskite 'T',\njei norite grizti i meniu - bet kuri kita simboli.\n";
                           cin >> meniukey;

                           if((meniukey=='t')||(meniukey=='T'))
                           {
                              kill(hash,dydis,ilgis);

                              cout << "Sena lentele sunaikinta.\n\nJei norite testi darba ir sukurti nauja destymo lentele, iveskite 'T',\njei norite darba su programa baigti - bet kuri kita simboli.\n";
                              cin >> meniukey;

                              if((meniukey!='t')&&(meniukey!='T'))
                                exit(0);
                              else
                              {
                                 cout << "Iveskite naujos destymo lenteles dydi:\n";
                                 do
                                 {
                                    if(dydis<1)
                                    {

                                       cout << "Jus turite ivesti teigiama skaiciu!\n";
                                    }
                                    cin >> pgb;
                                    if(ar_sk(pgb))
                                       dydis=ar_sk(pgb);
                                    else
                                       if((strlen(pgb)==1)&&(pgb[0]=='0'))
                                          dydis=0;
                                       else
                                       {

                                          cout << "Jus turite ivesti teigiama skaiciu!\n";
                                          dydis=0;
                                       }
                                 }
                                 while(dydis<1);

                                 hash=new struct sarasas*[dydis];
                                 for(int i=0;i<dydis;i++)
                                    hash[i]=NULL;
                              }
                           }
                        }
                        else
      /***************************** 1 ***************************************/
                           if(meniukey=='8')
                           {
                              sp_pagalba();
                           }
                           else
      /***************************** 0 ***************************************/
                          {
                              kill(hash,dydis,ilgis);
                              exit(0);
                              ar_sk(pgb1);
                           }

   }
   while(1);
}



